
//
// Visuzalization module for TETDM 
// VisualizationToolKit4.java Version 0.50 
// This is one of the sample modules.
// You should read the README file.
//


package module.VisualizationModules.VisualizationToolKit4;

import source.*;
import source.TextData.*;
//import source.Utility.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class VisualizationToolKit4 extends VisualizationModule implements MouseListener, MouseMotionListener
{
    String inEnglish[];
    String menu[];
    
    int fontSize = 20;
    
    String newLineCode;
    
    DisplayNetwork network;
    
    boolean sizeChanged;
    int touchNumber, oldTouchNumber;
    
    int mouseX,mouseY;

    boolean fieldMove;
    int oldMouseX, oldMouseY;
    
	
	public VisualizationToolKit4()
	{
		setModuleID(10005);			// Set your module ID after you have got it
        dataNumbers = new int[]{0,0,0,0,    // b,i,d,S
            0,0,0,1,    // bA,iA,dA,SA
            0,0,0};     // bA2,iA2,dA2
		setToolType(2);
	}
	
	public void initializePanel()
	{
        addMouseListener(this);
        addMouseMotionListener(this);
        
        inEnglish = new String[]{"English0","English1","English2","English3","English4","English5","English6"};
        menu = new String[inJapanese.length];
        
        newLineCode = System.getProperty("line.separator");
	}
	
	public void initializeData()
	{
        for(int i=0;i<menu.length;i++)
            if(isMenuInJapanese())
                menu[i] = inJapanese[i];
            else
                menu[i] = inEnglish[i];
        
        String noData[] = new String[]{"NO DATA"};
        
        network = new DisplayNetwork(noData, fontSize, Color.black);
        network.centeringFromScreenSize(sizeX,sizeY);
        
        touchNumber = -1;
	}

	public void displayOperations(int optionNumber)
	{
		switch(optionNumber)
		{
			case 0:
				repaint();
				break;
		}		
	}
	
    public boolean setData(int dataID, String data[])
    {
        switch(dataID)
        {
            case 0:
                network = new DisplayNetwork(data, fontSize, Color.black);
                network.centeringFromScreenSize(sizeX,sizeY);
                return true;
        }
        return false;    
    }
    
	//	public void setFont(){}	

    public void calculateXY()
    {
        network.reSizeByScreenSize(changeX, changeY);
//        network.centeringFromScreenSize(sizeX,sizeY);
    }
    
	//background
	public void drawBackground(Graphics2D g2)
	{
		g2.setColor(Color.blue);
        g2.fillRect(0,0, sizeX, sizeY);
	}
	
	public void drawData(Graphics2D g2)
	{
        g2.setColor(Color.green);
        network.fillRect(g2);
        
        g2.setColor(Color.black);
        network.drawRect(g2);
        
        network.drawWord(g2);
	}
    
	public void drawTouchedData(Graphics2D g2)
	{
        g2.setColor(Color.green);        
        network.fillRect(g2, touchNumber);
        
        g2.setColor(Color.red);
        network.drawRect(g2, touchNumber);
        
        network.drawWord(g2, touchNumber);
	}
	
	//////////paint
	public void paintComponent(Graphics g)
	{
		Graphics2D g2 = (Graphics2D)g;
		
		sizeChanged = getPanelSize();
        if(sizeChanged == true)
            calculateXY();
		
		drawBackground(g2);		//background
		drawData(g2);
        
        if(touchNumber >= 0)
            drawTouchedData(g2);
	}
	
	public void update(Graphics g)		//avoid from blinking
	{
		paintComponent(g);
	}
    
	//MouseListener
	public void mousePressed(MouseEvent me)	//Press
	{
		mouseX = me.getX();
		mouseY = me.getY();
		
		if(touchNumber < 0)
		{
			oldMouseX = mouseX;
			oldMouseY = mouseY;
			fieldMove = true;
			return;
		}
	}
	
	public void mouseReleased(MouseEvent me)	//Release
	{
		fieldMove = false;
	}
	
	public void mouseEntered(MouseEvent me){}	//Enter an area
	public void mouseExited(MouseEvent me){}	//Exit an area
	public void mouseClicked(MouseEvent me){}	//Click
    
	
	//MouseMotionListener
	public void mouseDragged(MouseEvent me)
    {
        mouseX = me.getX();
        mouseY = me.getY();
        
        if(touchNumber >= 0)
		{
            network.moveObjectByMouse(mouseX, mouseY, touchNumber);
			repaint();
		}
        
		if(fieldMove == true)
        {
            network.moveObjects(mouseX - oldMouseX, mouseY - oldMouseY);
            oldMouseX = mouseX;
            oldMouseY = mouseY;
            repaint();
        }
    }
	
	public void mouseMoved(MouseEvent me)
	{
		mouseX = me.getX();
		mouseY = me.getY();
        
		touchNumber = network.getOnMouseObject(mouseX, mouseY);
        
        if(touchNumber != oldTouchNumber)
        {
            repaint();            
            oldTouchNumber = touchNumber;
        }
	}
}
